---
title: "danog\\AsyncOrm\\DbArray: DB array interface."
description: ""

---
# `danog\AsyncOrm\DbArray`
[Back to index](../../index.md)

> Author: Daniil Gentili <daniil@daniil.it>  
> Author: Alexander Pankratov <alexander@i-c-a.su>  
  

DB array interface.  




## Method list:
* [`isset(TKey $key): bool`](#isset)
* [`offsetGet(TKey $offset): TValue`](#offsetGet)
* [`offsetExists(TKey $offset): bool`](#offsetExists)
* [`offsetSet(TKey $offset, TValue $value): void`](#offsetSet)
* [`offsetUnset(TKey $offset): void`](#offsetUnset)
* [`getArrayCopy(): array`](#getArrayCopy)
* [`unset(TKey $key): void`](#unset)
* [`set(TKey $key, TValue $value): void`](#set)
* [`get(TKey $key): ?TValue`](#get)
* [`clear(): void`](#clear)
* [`getInstance(\danog\AsyncOrm\DbArrayBuilder $config, (\danog\AsyncOrm\DbArray<TTKey, TValue>|null) $previous): \danog\AsyncOrm\DbArray<TTKey, TValue>`](#getInstance)
* [`count()`](#count)
* [`getIterator()`](#getIterator)

## Methods:
### <a name="isset"></a> `isset(TKey $key): bool`

Check if element exists.


Parameters:

* `$key`: `TKey`   


#### See also: 
* `TKey`




### <a name="offsetGet"></a> `offsetGet(TKey $offset): TValue`




Parameters:

* `$offset`: `TKey`   


#### See also: 
* `TKey`
* `TValue`




### <a name="offsetExists"></a> `offsetExists(TKey $offset): bool`




Parameters:

* `$offset`: `TKey`   


#### See also: 
* `TKey`




### <a name="offsetSet"></a> `offsetSet(TKey $offset, TValue $value): void`




Parameters:

* `$offset`: `TKey`   
* `$value`: `TValue`   


#### See also: 
* `TKey`
* `TValue`




### <a name="offsetUnset"></a> `offsetUnset(TKey $offset): void`




Parameters:

* `$offset`: `TKey`   


#### See also: 
* `TKey`




### <a name="getArrayCopy"></a> `getArrayCopy(): array`





### <a name="unset"></a> `unset(TKey $key): void`

Unset element.


Parameters:

* `$key`: `TKey`   


#### See also: 
* `TKey`




### <a name="set"></a> `set(TKey $key, TValue $value): void`

Set element.


Parameters:

* `$key`: `TKey`   
* `$value`: `TValue`   


#### See also: 
* `TKey`
* `TValue`




### <a name="get"></a> `get(TKey $key): ?TValue`

Get element.


Parameters:

* `$key`: `TKey`   


#### See also: 
* `TKey`
* `TValue`




### <a name="clear"></a> `clear(): void`

Clear all elements.



### <a name="getInstance"></a> `getInstance(\danog\AsyncOrm\DbArrayBuilder $config, (\danog\AsyncOrm\DbArray<TTKey, TValue>|null) $previous): \danog\AsyncOrm\DbArray<TTKey, TValue>`

Get instance.


Parameters:

* `$config`: `\danog\AsyncOrm\DbArrayBuilder`   
* `$previous`: `(\danog\AsyncOrm\DbArray<TTKey, TValue>|null)`   


#### See also: 
* [`\danog\AsyncOrm\DbArrayBuilder`: Contains configuration needed to build a DbArray.](../../danog/AsyncOrm/DbArrayBuilder.md)
* `TTKey`
* `TValue`




### <a name="count"></a> `count()`





### <a name="getIterator"></a> `getIterator()`





---
Generated by [danog/phpdoc](https://phpdoc.daniil.it)
