---
title: "danog\\AsyncOrm\\ValueType: Specifies the serializer to use when saving values."
description: ""

---
# `danog\AsyncOrm\ValueType`
[Back to index](../../index.md)

> Author: Daniil Gentili <daniil@daniil.it>  
> Author: Alexander Pankratov <alexander@i-c-a.su>  
  

Specifies the serializer to use when saving values.  




## Constants
* `danog\AsyncOrm\ValueType::STRING`: Direct storage of UTF-8 string values.

* `danog\AsyncOrm\ValueType::INT`: Direct storage of integer values.

* `danog\AsyncOrm\ValueType::BOOL`: Direct storage of boolean values.

* `danog\AsyncOrm\ValueType::FLOAT`: Direct storage of floating point (double precision) values.

* `danog\AsyncOrm\ValueType::OBJECT`: Objects extending DbObject, serialized as specified in the settings.

* `danog\AsyncOrm\ValueType::SCALAR`: Values of any scalar type, serialized as specified in the settings.
  
  Using SCALAR worsens performances, please use any of the other types if possible.

## Properties
* `$name`: `string` 
* `$value`: `string` 

## Method list:
* [`cases(): array`](#cases)
* [`from(string|int $value): static`](#from)
* [`tryFrom(string|int $value): ?static`](#tryFrom)

## Methods:
### <a name="cases"></a> `cases(): array`





### <a name="from"></a> `from(string|int $value): static`




Parameters:

* `$value`: `string|int`   



### <a name="tryFrom"></a> `tryFrom(string|int $value): ?static`




Parameters:

* `$value`: `string|int`   



---
Generated by [danog/phpdoc](https://phpdoc.daniil.it)
